<template>
    <div class="row">
        <!-- Start col -->
        <div class="col-lg-4 col-xl-3">
            <div class="card m-b-30">
                <div class="card-header">
                    <div class="row align-items-center">
                        <div class="col-9">
                            <h5 class="card-title mb-0">Categorias</h5>
                        </div>
                        <div class="col-3">
                            <ul class="list-inline-group text-right mb-0 pl-0">
                                <li class="list-inline-item mr-0 font-12">
                                    <a
                                        type="butto"
                                        v-on:click.prevent="reloadCategory()"
                                        ><i
                                            class="feather icon-refresh-cw font-16 text-primary ml-1"
                                        ></i
                                    ></a>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="card-body">
                    <div class="custom-control custom-checkbox">
                        <input
                            type="checkbox"
                            class="custom-control-input"
                            id="all"
                            checked=""
                            value="all"
                            v-model="categoria"
                            v-on:change.prevent="all"
                        />
                        <label class="custom-control-label" for="all"
                            >Todos</label
                        >
                    </div>
                    <div
                        v-for="item in categorias"
                        :key="item.id"
                        class="custom-control custom-checkbox"
                    >
                        <input
                            type="checkbox"
                            class="custom-control-input"
                            :id="'category-' + item.id"
                            :value="item.id"
                            v-model="categoria"
                            v-on:change.prevent="other"
                        />
                        <label
                            class="custom-control-label"
                            :for="'category-' + item.id"
                            >{{ item.name }}</label
                        >
                    </div>
                </div>
            </div>
        </div>
        <!-- End col -->
        <!-- Start col -->
        <div class="col-lg-8 col-xl-9">
            <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">Productos</h5>
                </div>
                <div class="card-body">
                    <!-- Start row -->

                    <!-- End row -->
                    <!-- Start row -->
                    <div class="row">
                        <!-- Start col -->
                        <div
                            v-for="(curso, i) in filtered"
                            :key="curso.id"
                            class="col-lg-6 col-xl-4"
                        >
                            <div
                                v-if="
                                    i >= paginate.show.init &&
                                        i + 1 < 12 * paginate.show.actual
                                "
                                class="product-bar m-b-30"
                            >
                                <div class="product-head">
                                    <a :href="'/curso/' + curso.slug_id"
                                        ><img
                                            :src="curso.feature_image"
                                            class="img-fluid"
                                            alt="product"
                                    /></a>
                                </div>
                                <div class="product-body py-3">
                                    <div class="row align-items-center">
                                        <div class="col-12">
                                            <div class="d-inline-block">
                                                <span
                                                    class="text-uppercase font-12 f-w-6"
                                                    >{{
                                                        curso.categorias
                                                            ? curso.categorias
                                                                  .name
                                                            : ""
                                                    }}</span
                                                >
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row align-items-center">
                                        <div class="col-12">
                                            <h6 class="mt-1 mb-3">
                                                {{ curso.title }}
                                            </h6>
                                        </div>
                                    </div>
                                    <div class="row align-items-center">
                                        <div class="col-6">
                                            <div class="text-left">
                                                <h5 class="f-w-7 mb-0">
                                                    <sup
                                                        v-if="curso.price_sale"
                                                        class="font-16"
                                                        >$</sup
                                                    >{{
                                                        curso.price_sale
                                                            ? curso.price_sale
                                                            : ""
                                                    }}
                                                    <span
                                                        :class="
                                                            curso.price_sale
                                                                ? 'text-danger descount'
                                                                : ''
                                                        "
                                                        ><sup class="font-16"
                                                            >$</sup
                                                        >{{ curso.price }}</span
                                                    >
                                                </h5>
                                            </div>
                                        </div>
                                        <div class="col-6">
                                            <!-- <div class="text-right">
                                                <button
                                                    type="button"
                                                    class="btn btn-primary-rgba font-18"
                                                >
                                                    <i
                                                        class="feather icon-shopping-bag"
                                                    ></i>
                                                </button>
                                            </div> -->
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- End col -->
                    </div>
                    <!-- Start row -->
                </div>
            </div>
            <div class="card m-b-30">
                <div class="card-body ecommerce-pagination">
                    <div class="row align-items-center">
                        <div class="col-lg-12 col-xl-6">
                            <p>
                                Mostrando {{ paginate.show.actual }} de
                                {{ paginate.pages }} págs, de
                                {{ paginate.entries }} entradas
                            </p>
                        </div>
                        <div
                            v-if="paginate.pagination"
                            class="col-lg-12 col-xl-6"
                        >
                            <nav aria-label="Page navigation example">
                                <ul class="pagination mb-0">
                                    <li
                                        v-if="paginate.show.actual > 1"
                                        class="page-item"
                                    >
                                        <a class="page-link" href="#"
                                            >Previous</a
                                        >
                                    </li>
                                    <li
                                        v-for="i in paginate.pages"
                                        :key="i"
                                        class="page-item"
                                    >
                                        <a
                                            :class="
                                                i == paginate.show.actual
                                                    ? 'page-link active'
                                                    : 'page-link'
                                            "
                                            v-on:click.prevent="page(i)"
                                            >{{ i }}</a
                                        >
                                    </li>
                                    <li
                                        v-if="
                                            paginate.show.actual <
                                                paginate.pages
                                        "
                                        class="page-item"
                                    >
                                        <a
                                            class="page-link"
                                            v-on:click.prevent="next()"
                                            >Next</a
                                        >
                                    </li>
                                </ul>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- End col -->
    </div>
</template>

<script>
export default {
    props: ["category"],
    created() {
        this.get();
    },
    mounted() {
        
    },
    data() {
        return {
            categorias: this.category,
            categoria: ["all"],
            cursos: [],
            filtered: [],
            paginate: {
                pagination: false,
                pages: 1,
                entries: 0,
                show: {
                    actual: 1,
                    init: 0
                }
            }
        };
    },
    methods: {
        reloadCategory() {
            var url = "/api/cursos/category";
            axios
                .get(url)
                .then(res => {
                    this.categorias = res.data;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        get() {
            axios
                .get("/api/cursos/curso")
                .then(res => {
                    this.cursos = res.data;
                    this.filtered = this.cursos;
                    this.pagination();
                })
                .catch(err => {
                    console.log(err);
                });
        },
        pagination() {
            if (this.filtered.length > 12) {
                this.paginate.pagination = true;
                this.paginate.pages = Math.ceil(this.filtered.length / 12);
                this.paginate.entries = this.filtered.length;
            } else {
                this.paginate.pagination = false;
                this.paginate.pages = 1;
                this.paginate.entries = this.filtered.length;
            }
        },
        all(e) {
            if (e.target.checked && e.target.value == "all") {
                this.categoria = ["all"];
                this.filtered = this.cursos;
            }
        },
        other(e) {
            if (e.target.checked) {
                let value = parseInt(e.target.value);
                if (this.categoria[0] == "all") {
                    this.categoria = [value];
                    this.filtered = [];
                }
                let filter = this.cursos.filter(
                    item => item.categorias.id == value
                );

                filter.forEach(e => {
                    this.filtered.push(e);
                });
                this.pagination();
            } else {
                let value = parseInt(e.target.value);
                let filter = this.filtered.filter(
                    item => item.categorias.id != value
                );
                this.filtered = filter;
                this.pagination();
            }
        },
        page(i) {
            this.paginate.show.actual = i;
            if (i == 1) {
                this.paginate.show.init = 0;
            } else {
                this.paginate.show.init = i * 12;
            }
        },
        next() {
            this.paginate.show.actual = this.paginate.show.actual + 1;
            this.paginate.show.init = this.paginate.show.actual * 12;
        }
    }
};
</script>
